<?php
// hook into qw_basics
add_filter('qw_basics', 'qw_basic_settings_pager');

// add default pager types
add_filter('qw_pager_types', 'qw_default_pager_types', 0);

/*
 * Basic Settings
 */
function qw_basic_settings_pager($basics){
  $basics['pager'] = array(
    'title' => 'Pager',
    'option_type' => 'display',
    'description' => 'Select which type of pager to use.',
    'form_callback' => 'qw_basic_pager_form',
    'weight' => 0,
  );
  
  return $basics;
}

/*
 * Setup pager types
 */
function qw_default_pager_types($pagers) {
  $pagers['default'] = array(
    'title' => 'Default',
    'callback' => 'qw_theme_pager_default'
  );
  $pagers['numbers']	= array(
    'title' => 'Page Numbers',
    'callback' => 'qw_theme_pager_numbers'
  );

  // WP PageNavi Plugin
  if(function_exists('wp_pagenavi')) {
    $pagers['pagenavi'] = array(
      'title' => 'PageNavi',
      'callback' => 'wp_pagenavi'
    );
  }
  return $pagers;
}

function qw_basic_pager_form($basic, $display)
{
  $pager_types = qw_all_pager_types();
  $use_pager      = ($display['page']['pager']['active']) ? 'checked="checked"': '';
  $pager_previous = isset($display['page']['pager']['previous']) ? $display['page']['pager']['previous'] : "";
  $pager_next     = isset($display['page']['pager']['next']) ? $display['page']['pager']['next'] : "";
  ?>
    <label class='qw-field-checkbox'>
      <input class='qw-js-title'
             type='checkbox'
             name="qw-query-options[display][page][pager][active]"
             <?php print $use_pager;?> />
      Use Pagination
    </label>
  
    <select class='qw-js-title' name="<?php print $basic['form_prefix']; ?>[page][pager][type]">
      <?php
        foreach($pager_types as $pager_name => $pager_options)
        {
          $selected = ($display['page']['pager']['type'] == $pager_name) ? 'selected="selected"' : '';
          ?>
          <option value="<?php echo $pager_name; ?>"
                  <?php echo $selected; ?>>
            <?php echo $pager_options['title']; ?>
          </option>
          <?php
        }
      ?>
    </select>
    <p>
      Use the following options to change the Default Pager labels.
    </p>
    <strong>Previous Page Label:</strong>
    <p>
      <input class='qw-js-title'
             type="text"
             name="<?php print $basic['form_prefix']; ?>[page][pager][previous]"
             value="<?php print $pager_previous; ?>" />
    </p>
    <strong>Next Page Label:</strong>
    <p>
      <input class='qw-js-title'
             type="text"
             name="<?php print $basic['form_prefix']; ?>[page][pager][next]"
             value="<?php print $pager_next; ?>" />
    </p>  
  <?php           
}